(*
  QuidoStackDll - Mapovn funkc z knihovny QuidoStackDll.dll

  Vydavatel :  Papouch s.r.o. - http://www.papouch.com/
  Autor     :  Martin Zmenk zamecnik@papouch.com

  Poznmky  : k pouit funkc jsou poteba knihovny QuidoStackDll.dll a CommIntfDll.dll,
              v ppad pouit pro USB jsou poteba t nainstalovan ovladae FTD direct drivers a knihova FTD2XX.dll
  Upozornn: veker parametry Index, a to i v ppad vstup a vstup quida, jsou slovny od 0 !!!
*)

unit q_QuidoDllMapD;
{$DEFINE InitDLL}

interface
uses windows,forms;
//konstatny
const QDLLName = 'QuidoStackDll.dll';
      //-- identifikace udlost (event) vyvolanch Quidem. pro zasln udlost registrujet jejich pjem pomoc qRegisterMsgNotifications nebo qRegisterCallBackNotifications
      qev_Base = $1FF;
      qev_InputsChange = qev_Base + 1; //zmna vstup - obecn oznm, z byla zaznamenna zmna nkterho vstupu
      qev_OutputsChange = qev_Base + 2; //zmna vstup - oznm, e byl znnn nkter vstup
      qev_InputChange = qev_Base + 3; //zmna vstupu - oznm, e byl zmnn jednotliv vstup (oznamuje kad vstup zvl᚝)
      qev_OutputChange = qev_Base + 4; //zmna vstupu - oznm, e byla zaznamenna zmna jednotlivho vstupu
      qev_CIOpen = qev_Base + 5; //-- oteven komunikanho kanlu quida
      qev_CIClose = qev_Base + 6; //-- uzaven komunikanho kanlu quida
//typy
type reStat = integer; //-- typ pro nvratovou hodnotu funkc; 0 = funkce probhla v podku, jinak chybov kd <> 0
     THandleNotificationEvent = procedure (Handle:THandle;Event:word;Param:word;CallBackID:cardinal);stdcall; //-- typ callbackov procedure pro oznamovn udlost (lze pout t oznamovn pes windows zprvy)

var

//--- Dynamicky mapovan funkce z DLL knihovny

DllInfo : function :pChar; stdcall; //-- vrac informan text o knihovn

qHandlesCount: function ():integer; stdcall; //-- vrac poet vytvoench Quid (funkcemi qCreateQuido...); -1 = chyba
qHandleByIndex: function (index:integer):THandle; stdcall; //-- vrac handle na Quido podle indexu (0..qHandlesCount-1); 0 = neplatn handle
ciHandlesCount: function ():integer; stdcall; //-- vrac poet vytvoench komunikanch rozhran (a ji spolen s Quidem nebo zvl᚝ v CommIntfDll.dll); -1=chyba
ciHandleByIndex: function (index:integer):THandle; stdcall; //-- vrac handle na komunikan rozhran podle indexu (0..ciHandlesCount-1); 0=chyba

qCreateQuido: function (connectionstring:pChar; deviceString:pchar):THandle; stdcall;
    //-- vytvoi objekt Quida. vrac handle vytvoenho objektu Quida; 0 = nepovedlo se vytvoit
    //--       connection string je etzec pro vytvoen komunikanho rozhrann, uruje komunikan kanl a jeho nastaven (sriov port, tcp, udp, nebo ftd_usb)
    //--       devicestring specifikuje parametry zazen Quido (adresu. v ppad e je na komunikanm kanlu pouze jedno zazen, lze zadat univerzln adresu $FE)
    //   Tvorba connectionstringu : jsou to hodnoty ve tvaru "parametr=hodnota" oddleny stednkem. uruj typ pipojen
    //          nejdleitjm parametrem je "provider", uruje typ komunikanho kanlu. me to bt SERIAL_PORT, TCP_CLIENT, UDP_CLIENT nebo FTD_USB
    //          kad kanl pak me mt dal parametry. SERIAL_PORT (comport=slo portu;baudrate=rychlost - nemus bt zadno), TCP_CLIENT(host=ip adresa zazen;port=tcp port zazen), UDP_CLIENT(stejn jako TCP), FTD_USB(index=poadov slo zazen; nebo device=st nzvu zazen; nebo serial_number=sriov slo zazen; nebo vid=vid;pid=pid; nebo nemus mt dn parametr, vezme se prvn pipojen zazen typu FTD_USB
    //          pklady: "provider=SERIAL_PORT;comport=1", "provider=TCP_CLIENT;host=192.168.1.254;port=10001", "provider=UDP_CLIENT;host=192.168.1.254;port=10001", "provider=FTD_USB;device=Quido"
    //   Tvorba devicestringu: p. "addr=12", "addr=$FE" ($ - znamen slo je zadno v hexa, $FE=univerzln adresa)

qCreateQuidoCI: function (ciHandle:THandle; devicestring:pChar):THandle; stdcall; //-- Vytvo objekt Quida, pouije se komunikan rozhrann ji explicitn vytvoen v CommIntfDll (ciHandle)
qCreateQuidoEx: function (connectionstring:pChar; deviceString:pchar; ciEventType:cardinal):THandle; stdcall; //-- umouje specifikovat zpsob voln udlost mezi komunikanm rozhrannm a objektem quida  - ciEventType (0 - sendmessage, 1 - callback, 2 - postmessage). nedoporuuje se pouvat, pokud k tomu nen dvod
qCreateQuidoCIEx: function (ciHandle:THandle; devicestring:pChar; ciEventType:cardinal):THandle; stdcall; //-- pouit explicitn vytvoenho komunikanho rozhrann, specifikace zpsobu voln udlost

qGetQuidoCIHandle : function (qHandle:THandle):THandle;stdcall;  //-- vrt handle komunikanho rozhran pipojenmu ke Quidu

qOpen : function (qHandle:THandle):reStat; stdcall; //-- oteve komunikan kanl Quida (oteve port, nave tcp spojen, ... podle typu komunikanho rozhran; nutno pro komunikaci se zazenm; vrt 0 pokud OK, chybov kd v opanm ppad (plat obecn pro nvratov typ reStat (integer))
qClose : function (qHandle:THandle):reStat; stdcall; //-- zave komunikan kanl Quida; vrt 0 pokud OK, chybov kd v opanm ppad
qIsOpened : function (qHandle:THandle;var Opened:longbool):reStat; stdcall; //-- zjist, zda je komunikan kanl quida oteven
qReleaseQuido : function (qHandle:THandle):reStat;stdcall; //-- zru objekt quida (vetn pslunho komunikanho rozhran - pokud nen zadno pi vytvoen explicitn pomoc handlu - qCreateQuidoCI)

qInputsCount : function (qHandle:THandle):integer;stdcall; //-- vrt poet vstup Quida; -1=chyba
qOutputsCount : function (qHandle:THandle):integer;stdcall; //-- vrt poet vstup Quida; -1=chyba
qInputCountersCount : function (qHandle:THandle):integer;stdcall; //-- vrt poet ta vstup; -1=chyba; standardn poet ta vstup=poet vstup, maximln vak 60

qInputStateByIndex : function (qHandle:THandle;Index:integer;var State:longbool):reStat;stdcall;//-- vrt do State stav vstupu podle indexu (0..poet vstup-1) (true=je na vstupu napt, false=neni); nvratov hodnota: 0-ok, jinak chyba
qOutputStateByIndex : function (qHandle:THandle;Index:integer;var State:longbool):reStat;stdcall;//-- vrt do State stav vstupu podle indexu (0..poet vstup-1)  (true=je na vstupu napt, false=neni); nvratov hodnota: 0-ok, jinak chyba
qInputCounterValueByIndex : function (qHandle:THandle;Index:integer;var Value:cardinal;NullCounter:longbool):reStat;stdcall; //-- vrt do Value hodnotu tae vstupu podle indexu (0..poet ta-1); pokud je NullCounter true, ta se zhy vynuluje

qGetOutputPWM: function(qHandle:THandle; Output:Integer; var PWM:Integer):reStat; stdcall;
qSetOutputPWM: function(qHandle:THandle; Output:Integer; const PWM:Integer):reStat; stdcall;

qGetInputPPS: function(qHandle:THandle; Input:Integer; Sec:Integer; var PPS:Integer):reStat; stdcall;

qGetInputs : function (qHandle:THandle; Inputs:pBoolean; var Len:Integer):reStat; stdcall; //-- vrt v poli stav vech vstup. do inputs je teba zadat ukazatel na pole alokovan na (poet vstup) byt; do Len je teba zadat velikost tohoto pole; pi pouit klasickho pole v delphi (array of boolean) je teba zadat ukazatel na prvn prvek pole (@pole[0]);
             //---  pokud je ve v podku, od Inputs se vypln stavy vstup, do Len se vypln aktuln velikost pole a nvratov hodnota je 0
             //---  pokud se do Inputs zad nil, do Len se vypln potebn velikost pole a nvratov hodnota je 0
             //---  pokud se vyskytne chyba (stav vstup nelze zjistit, nebo zadan velikost Len je nedostaten), nvratov hodnota je chybov kd <> 0
qGetOutputs : function (qHandle:THandle; Outputs:pBoolean; var Len:Integer):reStat; stdcall;//-- vrt v poli stav vech vstup. princip jako u qGetInputs

qSetOutput : function (qHandle:THandle; Index:Integer; State:longbool):reStat; stdcall;//-- Nastav stav vstupu Quida podle indexu (State:true=sepnout,false=rozepnout). pokud je nvratov hodnota 0=OK, jinach chyba
qSetOutputTimered : function (qHandle:THandle; Index:Integer; State:Boolean; Time:integer):reStat; stdcall;//-- Nastav stav vstupu na urit as (Time=as ve vteinch).pokud je nvratov hodnota 0=OK, jinach chyba

qSetOutputs : function (qhandle:THandle; Outputs:pBoolean; Len:Integer):reStat;  stdcall;//-- Nastav najednou stav vech vstup. do outputs se zad pole boolen (1 bytovch). Len uruje velikost pole; pokud je nvratov hodnota 0=OK, jinach chyba

qGetRecentInputsState : function (qHandle:THandle; Inputs:pBoolean; var Len:Integer):reStat; stdcall; //-- vrt v poli naposledy znm stav vstup - stejn jako qGetInputs, akort se nedotazuje pmo zazen, ale vrac naposledy zjitn stav. vhodn nap. po udlosti qev_InputsChange.
qGetRecentOutputsState : function(qHandle:THandle; Outputs:pBoolean; var Len:integer):reStat; stdcall; //-- vrt v poli naposledy znm stav vstup - procuje jako qGetRecentInputsState

qGetRecentInputByIndex : function (qHandle:THandle; Index:Integer; var State:longbool):reStat;stdcall; //-- vrt naposledy znm stav vstupu Quida podle Indexu (jako qGetInputStateByIndex, akort se nedotazuje pmo zazen, ale vrac naposledy zjitn stav
qGetRecentOutputByIndex : function (qHandle:THandle; Index:Integer; var State:longbool):reStat;stdcall;//-- vrt naposledy znm stav vstupu Quida podle Indexu. pracuje jako qGetRecentInputByIndex
qGetRecentInputCounterByIndex:function(qHandle:THandle; Index:Integer; var Value:integer):reStat;stdcall; //-- vrt naposledy znm stav tae vstupu Quida podle Indexu.
qGetRecentCounterSettingByIndex:function(qHandle:THandle; Index:Integer; var Rising,Falling:longbool):reStat;stdcall; //-- vrt naposledy znm stav nastaven vstupu Quida podle Indexu

qRefreshRecentStates: function(qHandle:THandle;Inputs:longbool=true; Outputs:longbool=true; Counters:longbool=true; CounterSettings:longbool=true):reStat;stdcall;
//qCheckInputsState: function (qHandle:THandle; Wait:longbool):reStat; stdcall; //-- zjist ze zazen stavy vstup. ty jsou pak k dispozici pomoc funkc qGetRecentInputsstate a qGetRecentInputByIndex
//qCheckOutputsState: function (qHandle:THandle; Wait:longbool):reStat; stdcall; //-- zjist ze zazen stavy vstup. ty jou pak k dispozici pomoc funkc qGetRecentOutputsState a qGetRecentOutputByIndex

qGetAutoNotify : function (qHandle:THandle; var Value:longbool):reStat;stdcall; //-- vrt do Value zda je aktivovno automatick oznamovn zmny stavu vstup (pokud je registrovno oznamovn pomoc qRegisterMsgNotifications nebo qRegisterCallBackNotifications;
qSetAutoNotify : function(qHandle:THandle; Value:longbool):reStat;stdcall; //-- nastav nebo zru automatick oznamovn zmny stavu vstup (true=nastavit, false=zruit)

qSetCounterSetting :function (qHandle:THandle;Index:integer; Rising,Falling:longbool):reStat;stdcall; //-- Nastaven tae (na kter hrany signlu se inkrementuje - rising=nbn, falling=sestupn)
qGetCounterSetting :function (qHandle:THandle;Index:integer; var Rising,Falling:longbool):reStat;stdcall; //-- Zjitn nastaven tae

qRegisterMsgNotifications : function (Handle:THandle;WHandle:hwnd;Msg:cardinal;blocking:longbool=true):reStat; stdcall; //-- registruje zasln udlost Quida pomoc Windows zprv (Oteven a zaven komunikanho kanlu, zmny stav vstup, ...). zadv se hWnd okna, kter zprvu pijm a identifikaci zprvy, kter je zaslna. v parametru zprvy WParam je zasln handle Quida, kter ji zasl, v LParamLo je zasln typ udlosti, LParamHi ppadn dodaten parametr
qUnregisterMsgNotifications : function (Handle:THandle):reStat; stdcall;  //-- ru zasln udlost Quida pomoc Windows zprv
qRegisterCallBackNotifications : function (Handle:THandle;CallBackEntryPoint:THandleNotificationEvent;CallBackID:cardinal):reStat;stdcall; //-- registruje zasln udlost Quida pomoc voln callbackov funkce formtu THandleNotificationEvent
qUnregisterCallBackNotifications : function (Handle:THandle):reStat;stdcall;//-- ru zasln udlost Quida pomoc callbackov funkce

qInfo : function (qHandle:THandle; Info:pChar; var Len:integer):reStat; stdcall; //-- vrac textovou identifikaci zazen (Quida)
qReset : function (qHandle:THandle):reStat;stdcall; //-- Resetovn zazen
qGetAddress:function (qHandle:THandle;var Addr:integer):reStat; stdcall; //-- zjitn adresy zazen
qSetAddress:function (qHandle:THandle;var Addr:integer):reStat; stdcall; //-- nastaven adresy zazen (0-253)
qGetUserData:function (qHandle:THandle; UserData:pChar;var Len:integer):reStat; stdcall; //-- zskn uvatelskch dat (16 byt)
qSetUserData:function (qHandle:THandle; UserData:pChar; Len:integer):reStat; stdcall; //-- nastaven uivatelskch dat (16 byt)
qGetFactoryInfo:function (qHandle:THandle; var ProductID:integer; var SerialNumber:integer;var FactoryData:cardinal):reStat; stdcall; //-- zjskn vrobnch dat (sriovho sla,..) zazen

qSndRcvSpin97: function (qHandle:THandle;Inst:byte;Data:pointer;DataLen:integer;
                  var RcvAck:byte;RcvData:pointer;var RcvDataLen:integer;MaxTimeOut:integer):reStat;stdcall;
                  //-- Zale spinel paket, zadan instrukc Inst a daty Data (velikosti DataLen) a ek na odpov (maximln MaxTimeOut milisekund)
                  // Pokud pijde odpov, nvratov hodnota je 0, do bufferu RcvData o velikosti RcvDataLen se zapou vrcen data spinel paketu a v RcvDataLen se vrt aktuln velikost dat.
                  // RcvAck vrt kd odpovdi (0 = OK)
                  // Pokud se paket neodele, nebo se nevrt odpov, nebo vznikne jin chyba, nvratov hodnota <> 0

ciGetConnectionStringDlg:function(OutConnStr:pChar;var Len:integer;var OKReturn:longbool;DefaultValue:pChar=nil;Caption:pChar=nil):reStat; stdcall; //-- Vyvol dialogov okno pro vytvoen pipojovacho etzce (connection string). Vrac hodnotu<>0, pokud nastala chyba
                        //-- OutConStr:sem je vrcen connectionstring, Len:velikost bufferu OutConStr, OKReturn:vrceno true, pokut bylo stisknuto OK, DefaultValue:ppadn pednastaven vchozho connectionstringu, Caption: vlastn titulek dialogu

LastError : function:reStat;stdcall; //-- vrt chybov kd naposledy volan funkce. 0=funkce probhla v podku
LastErrorText:function (Text:pchar;var Size:integer):reStat;stdcall; //-- vrt text chyby naposledy volan funkce

function _LastErrorText:string; //-- zjednoduuje pouit LastErrorText
procedure RaiseLastError(RaiseIfNoError:boolean=false); //-- procedura, kter vyvol vyjmku s odpovdajcm textem chyby ktr vznikla pi naposledy volan funkci, pokud vznikla
function _GetConnectionStringDlg(var ConnectionString:string;Caption:string=''):boolean;
function _SndRcvSpin97(qHandle:THandle;Inst:byte;const Data:string;var RcvAck:byte;var RcvData:string;MaxTimeOut:integer=500):boolean;

//-- funkce pro detekci spnosti zaveden knihovny
function QDllOK:boolean; //-- vrac true, pokud byla knihovna a vechny jej funkce v podku zavedeny
function QDllInitMsg:string; //-- vrac text chyby, pokud nebyla knihovna v podku zavedena
procedure QDTestInit; //-- nedl nic, pokud byla knihovna v podku zavedena, jinak vyvol vyjmku s textem chyby


implementation
uses SysUtils,messages;
var DllInited:boolean;
    hDll:THandle;
    DllInitMsg:string;


function QDllInitMsg:string;
begin
  if QDllOK then result:='' else result:=DllInitMsg;
end;

procedure QDTestInit;
begin
  if not qdllok then raise Exception.Create(DllInitMsg);
end;

function _LastErrorText:string;
var S:string;
    l:integer;
begin
try
  result:='';
  if LastError <> 0 then
  begin
    LastErrorText(nil,L);
    setlength(s,L);
    if L>0 then
    if LastErrorText(@S[1],L)=0 then result:=copy(s,1,L) else result:='Unknown error in LastErrorText.';
  end;
except
  on e:exception do raise exception.Create('Error in calling LastErrorText.'#13#10+ e.Message);
end;
end;

procedure RaiseLastError(RaiseIfNoError:boolean=false);
var S:string;
    l:integer;
begin
  if (LastError <> 0) then
  begin
    raise exception.Create(_LastErrorText);
  end
   else
  begin
    if RaiseIfNoError
     then raise Exception.Create('Unknown error');
  end;
end;

function _GetConnectionStringDlg(var ConnectionString:string;Caption:string=''):boolean;
var s,dv:string;
    L:integer;
    R:longbool;
begin
  l:=256;
  result:=false;
  setlength(s,l);
  dv:=ConnectionString;
  if ciGetConnectionStringDlg(@s[1],L,R,pansichar(DV),pansichar(Caption))=0 then
  begin
    if R then
    begin
      setlength(s,l);
      ConnectionString:=s;
      if s<>'' then result:=true;
    end;
  end else raise Exception.Create(_LastErrorText);
end;

function _SndRcvSpin97(qHandle:THandle;Inst:byte;const Data:string;var RcvAck:byte;var RcvData:string;MaxTimeOut:integer=500):boolean;
var S:string;
    Len:integer;
    P:Pointer;
begin
  Len:=512;
  setlength(S,Len);
  if (length(Data)>0) then P:=@Data[1] else P:=nil;
  result:= qSndRcvSpin97(qHandle,Inst,P,length(Data),RcvAck,@S[1],Len,MaxTimeOut)=0;
  if result then
  begin
    setlength(S,Len);
    RcvData:=S;
  end;
end;


function QDllOK:boolean;  
{}procedure Map(var ProcAddr:Pointer;const Name:string);
{}begin
    ProcAddr:=GetProcAddress(hDll,pansichar(Name));
    if not assigned(ProcAddr) then raise Exception.Create('Can not map function '+Name+ ' in '+qdllname);
{}end;
begin
  result:=true;
  if DllInited then
  begin
    result:=(hDLL<>0);
  end else
  begin
    try
      DllInited:=true;
      result:=false;
      dllinitmsg:='';
      hDLL := LoadLibrary(pansichar(qdllname));
      if hDLL=0 then
      begin
        DllInitMsg := 'Can''t load library '+QDLLName + '.';
        exit;
      end;
      //Namapovn funkc
      Map(@DllInfo,'DllInfo');
      Map(@ciHandlesCount,'ciHandlesCount');
      Map(@ciHandleByIndex,'ciHandleByIndex');
      Map(@qHandlesCount,'qHandlesCount');
      Map(@qHandleByIndex,'qHandleByIndex');
      Map(@qCreateQuidoCI,'qCreateQuidoCI');
      Map(@qCreateQuido,'qCreateQuido');
      Map(@qCreateQuidoCIEx,'qCreateQuidoCIEx');
      Map(@qCreateQuidoEx,'qCreateQuidoEx');
      Map(@qGetQuidoCIHandle,'qGetQuidoCIHandle');
      Map(@qOpen,'qOpen');
      Map(@qClose,'qClose');
      Map(@qIsOpened,'qIsOpened');
      Map(@qReleaseQuido,'qReleaseQuido');
      Map(@qInputsCount,'qInputsCount');
      Map(@qOutputsCount,'qOutputsCount');
      Map(@qInputCountersCount,'qInputCountersCount');
      Map(@qInputStateByIndex,'qInputStateByIndex');
      Map(@qOutputStateByIndex,'qOutputStateByIndex');
      Map(@qInputCounterValueByIndex,'qInputCounterValueByIndex');
      Map(@qGetOutputPWM,'qGetOutputPWM');
      Map(@qSetOutputPWM,'qSetOutputPWM');
      Map(@qGetInputPPS,'qGetInputPPS');
      Map(@qGetInputs,'qGetInputs');
      Map(@qGetOutputs,'qGetOutputs');
      Map(@qSetOutput,'qSetOutput');
      Map(@qSetOutputTimered,'qSetOutputTimered');
      Map(@qSetOutputs,'qSetOutputs');
      Map(@qGetRecentInputsState ,'qGetRecentInputsState');
      Map(@qGetRecentOutputsState,'qGetRecentOutputsState');
      Map(@qGetRecentInputByIndex,'qGetRecentInputByIndex');
      Map(@qGetRecentOutputByIndex,'qGetRecentOutputByIndex');
      Map(@qGetRecentInputCounterByIndex,'qGetRecentInputCounterByIndex');
      Map(@qGetRecentCounterSettingByIndex,'qGetRecentCounterSettingByIndex');
      Map(@qRefreshRecentStates,'qRefreshRecentStates');
      Map(@qGetAutoNotify,'qGetAutoNotify');
      Map(@qSetAutoNotify,'qSetAutoNotify');
      Map(@qRegisterMsgNotifications,'qRegisterMsgNotifications');
      Map(@qUnregisterMsgNotifications ,'qUnregisterMsgNotifications');
      Map(@qRegisterCallBackNotifications,'qRegisterCallBackNotifications');
      Map(@qUnregisterCallBackNotifications,'qUnregisterCallBackNotifications');
      Map(@qInfo,'qInfo');
      Map(@qReset,'qReset');
      Map(@qGetAddress,'qGetAddress');
      Map(@qSetAddress,'qSetAddress');
      Map(@qGetUserData,'qGetUserData');
      Map(@qSetUserData,'qSetUserData');
      Map(@qGetFactoryInfo,'qGetFactoryInfo');

      Map(@LastError,'LastError');
      Map(@LastErrorText,'LastErrorText');
      Map(@ciGetConnectionStringDlg,'ciGetConnectionStringDlg');
      Map(@qGetCounterSetting,'qGetCounterSetting');
      Map(@qSetCounterSetting,'qSetCounterSetting');

      Map(@qSndRcvSpin97,'qSndRcvSpin97');
      result:=true;
    except
      on e:exception do
      begin
        if hDll<>0 then
        begin
           FreeLibrary(hDLL);
           hDll := 0;
        end;
        DllInitMsg := e.Message;
      end;
    end;
  end;
end;

initialization
 //-- inicializace zaveden knihovny
 DllInited := false;
 hDll := 0;
 {$IFDEF InitDLL}
 if not QDllOK then
  if MessageBox(0,pansichar(DllInitMsg+#13#10+'Terminate aplication?'),'Error in loading library',MB_YESNO+MB_ICONERROR)=IDYes
    then PostMessage(Application.Handle,WM_QUIT,0,0);
 {$ENDIF}
finalization
 if hDLL<>0 then FreeLibrary(hDll);
 hDll:=0;
end.
